<?php
/**
 * @copyright   Copyright (C) Chatbro. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

namespace Chatbro\Component\Chatbrocomponent\Administrator\Dispatcher;

defined('_JEXEC') || die();

use Joomla\CMS\Dispatcher\ComponentDispatcher;
use Throwable;

class Dispatcher extends ComponentDispatcher
{
	// protected $app;
	// protected $option = 'com_chatbro';
	// protected $defaultController = 'chatbro';

	public function dispatch()
	{
		// Check the minimum supported PHP version
		$minPHPVersion = '7.3.33';

		if (version_compare(PHP_VERSION, $minPHPVersion, 'lt')) {
			throw new \RuntimeException(
				sprintf(
					'Chatbro requires at least PHP version %s. Your server currently uses PHP version %s. Please upgrade your PHP version.',
					$minPHPVersion,
					PHP_VERSION
				)
			);
		}

		try {
			$this->onBeforeDispatch();
			parent::dispatch();
		} catch (Throwable $e) {
			throw $e;
		}
	}

	protected function onBeforeDispatch()
	{
		$this->checkAccess();

		if (!defined('CHATBROENGINE')) {
			define('CHATBROENGINE', 1);
		}
	}
}
